using Core.Actions;
using Maybe;

namespace Infrastructure.Providers
{
    public static class HeadActionsProvider
    {
        public static RetrieveHead ProvideRetrieveHeadAction()
        {
            return new RetrieveHead(
                RepositoryProvider.ProvideHeadRepository());
        }

        public static TouchBrainSector ProvideTouchBrainSector()
        {
            return new TouchBrainSector(
                RepositoryProvider.ProvideHeadRepository());
        }
        
        public static CreateHead ProvideCreateHead()
        {
            return new CreateHead(RepositoryProvider.ProvideHeadRepository(),
                ConfigurationProvider.ProvideDefaultHeadConfiguration());
        }

        public static BotAction ProvideBotAction()
        {
            return new BotAction(RepositoryProvider.ProvideHeadRepository(), 
                ConfigurationProvider.ProvideDefaultBotConfiguration());
        }

        public static GetCurrentPoints ProvideGetCurrentPointsAction()
        {
            return new GetCurrentPoints(RepositoryProvider.ProvideHeadRepository());
        }
    }
}