using Infrastructure.Repository;
using Maybe;
using Presentation;

namespace Infrastructure.Providers
{
    public static class RepositoryProvider
    {
        private static Maybe<HeadRepository> headRepository = Maybe<HeadRepository>.Nothing;
        
        public static HeadRepository ProvideHeadRepository()
        {
            return headRepository
                .SelectOrElse(it => it, () =>
                {
                    HeadRepository headRepositoryValue = new InMemoryHeadRepository();
                    headRepository = headRepositoryValue.ToMaybe();
                    return headRepository.Value;
                });
        }
    }
}