using System;
using System.Collections.Generic;
using Core.Domain;
using UniRx;

namespace Presentation
{
    public interface HeadView
    {
        event Action<BrainSector> OnBrainSectorTouched;
        event Action OnStart;
        event Action OnExit;
        void ShowHead(List<HeadPiece> headPieces);
        IObservable<Unit> OnEveryUpdate();
        void FinishGame(double score);
        void ShowBrainSectorCooldown(BrainSector brainSector, float brainSectorCooldown);
        void UpdateCurrentPoints(double currentPoints);
        void BrainTouchedSfx();
    }
}