using System;
using System.Collections.Generic;

namespace Utils
{
    public class Disposer : IDisposable
    {
        List<IDisposable> disposables = new List<IDisposable>();

        public static Disposer Create()
        {
            return new Disposer();
        }

        public Disposer Add(IDisposable disposable)
        {
            disposables.Add(disposable);
            return this;
        }

        public void Dispose()
        {
            foreach (var disposable in disposables){
                if(disposable != null)
                    disposable.Dispose();
            }

            disposables.Clear();
        }
    }
    
    public static class DisposerExtensions
    {
        public static void AddTo(this IDisposable disposable, Disposer disposer)
        {
            disposer.Add(disposable);
        }
    }
}